#include <stdio.h>

int a[200000];

int main()
{
	int n, q;
	scanf("%d %d", &n, &q);
	for(int i = 0; i < n; i++)
	{
		scanf("%d", &a[i]);
	}
	
	for(int i = 0; i < q; i++)
	{
		int l, d;
		scanf("%d %d", &l, &d);
		int rez = a[l - 1];
		for(int j = l; j <= d; j++)
		{
			rez = rez & a[j - 1];
		}
		printf("%d\n", rez);
	}
}